#! /usr/bin/python
# -*- coding: utf-8 -*-
'''
Created on 11.09.2012

@author: tolmi
'''
import ConfigParser, MySQLdb, sys, os, codecs, base64, time

class StoreDrupal7DB(object):
    '''
    classdocs
        Пока ничего не придумал. А в связи с глобальной ленью скорее всего никогда и не напишу.
    '''    
    error = ''
    error_cnt = 0
    error_cnt_imm = 0
    db_host = ''
    db_base = ''
    db_user = ''
    db_passwd = ''
    db_conn = None
    db_cursor = None
    drupal_uid = 1
    sConfigFileName = u''
    unixstamp = 0L
    ArgumentsArray = None
    last_query_rows = 0
    stferr_utf = None
    stdout_utf = None
    def ReadConfigFile(self, FileName):
        try:
            self.sConfigFileName = os.path.expanduser(FileName)
            cfp = ConfigParser.ConfigParser()
            conf_fp = codecs.open(self.sConfigFileName, "r+t", 'utf8')
            cfp.readfp(conf_fp)
            self.db_host = cfp.get(section='database', option='hostname')    
            self.db_base = cfp.get(section='database', option='dbname')
            self.db_user = cfp.get(section='database', option='dbuser')
            self.db_passwd = base64.b64decode(cfp.get(section='database', option='dbpassword'))
            self.drupal_uid = cfp.getint(section='drupal', option='uid')
            conf_fp.close()
            return True
        except Exception as e:
            print >> self.stferr_utf, repr(e)
            self.error += repr(e) + '\n'
            self.error_cnt += 1
            return False
    def OpenDBConnection(self):
        try:
            if self.db_conn != None:
                try:
                    self.db_conn.close()
                    self.db_conn = None
                except:
                    pass
            self.db_conn = MySQLdb.connect(host=self.db_host, user=self.db_user, passwd=self.db_passwd, db=self.db_base, use_unicode=1, charset='utf8')
            self.db_conn.set_character_set('utf8')
            self.db_cursor = self.db_conn.cursor(MySQLdb.cursors.DictCursor)
            self.db_cursor.execute('SET NAMES utf8')
            self.db_cursor.execute('SET CHARACTER SET utf8')
            self.db_cursor.execute('SET character_set_connection=utf8')
            self.db_cursor.execute("SET sql_mode = 'ANSI,STRICT_TRANS_TABLES,STRICT_ALL_TABLES,NO_ZERO_IN_DATE,NO_ZERO_DATE,ERROR_FOR_DIVISION_BY_ZERO,NO_AUTO_CREATE_USER'")
            return True
        except Exception as e:
            print >> self.stderr_utf, repr(e)
            self.error += repr(e) + '\n'
            self.error_cnt += 1
            return False
    def DeleteAllPlayHistory(self, file_nid=None):
        try:
            inp_tup = ('node', 'filepath', 0, file_nid)
            r1 = self.db_cursor.execute('DELETE FROM field_data_field_date_time WHERE entity_type=%s AND bundle=%s AND deleted=%s AND entity_id=%s', inp_tup)
            r2 = self.db_cursor.execute('DELETE FROM field_revision_field_date_time WHERE entity_type=%s AND bundle=%s AND deleted=%s AND entity_id=%s', inp_tup)
            return (r1, r2)
        except Exception as e:
            print >> self.stderr_utf, repr(e)
            self.error += repr(e) + '\n'
            self.error_cnt += 1
    def AddTrackPlayHistory(self, file_nid=None, timestamp=None):
        if file_nid is None: return -1
        if timestamp == None: timestamp = self.unixstamp
        try:
            inp_tup = ('node', 'filepath', 0, file_nid)
            r1 = self.db_cursor.execute('SELECT max(delta) as result from field_data_field_date_time WHERE entity_type=%s AND bundle=%s AND deleted=%s AND entity_id=%s', inp_tup)
            if r1 == 0: #Empty field
                r2 = self.AddNodeFieldDataAndRevision(field_type=4, fieldname='field_date_time', nid=file_nid, nodetype='filepath', arg_value=timestamp, delta=0)
                return r2
            elif r1 > 0:
                r2 = self.db_cursor.fetchone()
                if r2['result'] is None:
                    current_delta = 0
                else: 
                    current_delta = r2['result'] + 1
                r2 = self.AddNodeFieldDataAndRevision(field_type=4, fieldname='field_date_time', nid=file_nid, nodetype='filepath', arg_value=time.strftime('%Y-%m-%d %H:%M:%S', time.gmtime(timestamp)), delta=current_delta)
                return r2
        except Exception as e:
            print >> self.stderr_utf, repr(e)
            self.error += repr(e) + '\n'
            self.error_cnt += 1
            return repr(e)        
    def CheckNode(self, nodetype='', nodefilter=''):
        try:
            sql = "SELECT nid FROM node WHERE type=%s AND title = %s ;"
            numrows = self.db_cursor.execute(sql, (nodetype, nodefilter))           
            if nodetype != 'track':
                if numrows < 1 :
                    return 0
                r = self.db_cursor.fetchone()
                return r['nid']
            elif nodetype == 'track':
                r = self.db_cursor.fetchall() # Все с таким именем
                for rr in r:
                    cnid = rr['nid']
                    #Ищем полное соответствие
                    itrack = self.ArgumentsArray.get('track_number', 0)
                    if itrack is None or (not  (type(itrack) == long or type(itrack) == str or type(itrack) == int)) :
                        itrack = 0 
                    itrack = long(itrack)
                    iduration = self.ArgumentsArray.get('duration', 0)
                    iartist = self.ArgumentsArray.get('artist_nid', 0)
                    ialbum = self.ArgumentsArray.get('album_nid', 0)
                    dtrack = self.GetFieldByNID(cnid, 'field_track_no', 4)
                    dduration = self.GetFieldByNID(cnid, 'field_duration', 4)
                    dartist = self.GetFieldByNID(cnid, 'field_artist', 5)
                    dalbum = self.GetFieldByNID(cnid, 'field_album', 5)
                    if itrack <= 0 or dtrack <= 0 or dtrack is None : dtrack = itrack
                    if itrack == dtrack and iartist == dartist and ialbum == dalbum and abs(iduration - dduration) < 5 :
                        return cnid
                # Всё прошли, ничего похожего не нашли.
                return 0 
        except Exception as e:
            print >> self.stderr_utf, repr(e)
            self.error += repr(e) + '\n'
            self.error_cnt += 1
            return -1
    def GetFieldByNID(self, nid, fieldname, fieldtype):
        try:
            if fieldtype == 1 or fieldtype == 2: #Text
                sql = ('SELECT %s_value as RValue,delta FROM field_data_%s WHERE entity_type= ' % (fieldname, fieldname)) + '%s AND entity_id=%s ORDER BY delta ASC;'
            elif fieldtype == 4: # Number
                sql = ('SELECT %s_value as RValue,delta FROM field_data_%s WHERE entity_type= ' % (fieldname, fieldname)) + '%s AND entity_id=%s ORDER BY delta ASC;'                
            elif fieldtype == 5: #NID
                sql = ('SELECT %s_nid as RValue,delta FROM field_data_%s WHERE entity_type= ' % (fieldname, fieldname)) + '%s AND entity_id=%s ORDER BY delta ASC;'
            elif fieldtype == 6: #Rating
                sql = ('SELECT %s_rating as RValue,delta FROM field_data_%s WHERE entity_type= ' % (fieldname, fieldname)) + '%s AND entity_id=%s ORDER BY delta ASC;'                
            else:
                return None          
            numrows = self.db_cursor.execute(sql, ('node', nid))
            if numrows > 1: 
                rr = self.db_cursor.fetchall()
                rv = []
                for r in rr:
                    rv.append(r['RValue'])           
                return rv
            elif numrows == 1:
                rr = self.db_cursor.fetchone()
                return rr['RValue']
            else:
                return None
        except Exception as e:
            print >> self.stderr_utf, repr(e)
            self.error += repr(e) + '\n'
            self.error_cnt += 1
            return None
    def GetTitleByNID(self, nid):
        try:
            sql = 'SELECT nid,title from node where nid=%s order by nid ASC;'
            self.last_query_rows = self.db_cursor.execute(sql, (nid,))
            rr = self.db_cursor.fetchall()
            if self.last_query_rows > 1:
                rra = []
                for r in rr:
                    rra.append(r['title'])
                return rra
            elif self.last_query_rows == 1:
                return rr[0].get('title')
            else:
                return None
        except Exception as e:
            print >> self.stderr_utf, repr(e)
            self.error += repr(e) + '\n'
            self.error_cnt += 1
            return None
    def IncrementPlayCount(self, nid):
        try:
            sql1 = 'UPDATE field_data_field_count SET field_count_value=field_count_value+1 WHERE entity_type=%s and entity_id=%s and delta=0;'
            sql2 = 'UPDATE field_revision_field_count SET field_count_value=field_count_value+1 WHERE entity_type=%s and entity_id=%s and delta=0;'
            self.db_cursor.execute('START TRANSACTION')
            r1 = self.db_cursor.execute(sql1, ('node', nid))
            r2 = self.db_cursor.execute(sql2, ('node', nid))
            self.db_conn.commit()  
            r3 = self.GetFieldByNID(nid=nid, fieldname='field_count', fieldtype=4)
            return (r3, r1, r2) 
        except Exception as e:
            print >> self.stderr_utf, repr(e)
            self.error += repr(e) + '\n'
            self.error_cnt += 1
            return None
    def UpdateExistingTrackByNID(self, nid):
        try:
            igenre_name = self.ArgumentsArray.get('genre_name', 0)
            new_genre_nid = self.CheckAddNodeType(nodetype='genre', nodefilter=igenre_name, timestamp=0)
            ifilepath_name = self.ArgumentsArray.get('filepath', '#ERROR#')
            new_filepath_nid = self.CheckAddNodeType(nodetype='filepath', nodefilter=ifilepath_name, timestamp=0)            
            rr1 = self.UpdateMVnidByNID(tnid=nid, param_name='field_genre', ntype='track', new_value=new_genre_nid)
            rr2 = self.UpdateMVnidByNID(tnid=nid, param_name='field_filepath', ntype='track', new_value=new_filepath_nid)
            new_count = self.ArgumentsArray.get('play_count', 0)
            old_count = self.GetFieldByNID(nid=nid, fieldname='field_count', fieldtype=4)
            if new_count > old_count: #Update count 
                rr6 = self.UpdateSValueByNID(param_name='field_count', tnid=nid, ntype=4, new_value=new_count)
                old_count = new_count
            else:
                rr6 = None
            new_rate = self.ArgumentsArray.get('rate', 0)
            old_rate = self.GetFieldByNID(nid=nid, fieldname='field_rate', fieldtype=4)
            if old_rate == 0: # Старая методика
                if new_rate == 0: # И опять 
                    new_rate = int(round((old_count / (old_count + 1.1)) * 50))
                else:
                    new_rate = int(round((int((old_count / (old_count + 1.1)) * 50) + new_rate - 0.1) / 2.))
            else:
                if new_rate == 0: # И опять 
                    new_rate = int(round((int((old_count / (old_count + 1.1)) * 50) + old_rate - 0.1) / 2.))
                else:
                    if new_rate < old_rate:
                        new_rate = int(round((old_rate + new_rate - 0.1) / 2.0))
                    else: 
                        new_rate = int(new_rate) # оставляем как есть
            rr3 = self.UpdateSValueByNID(param_name='field_rate', tnid=nid, ntype=4, new_value=new_rate)
            new_rating = self.ArgumentsArray.get('rating', 0)
            old_rating = self.GetFieldByNID(nid=nid, fieldname='field_rating', fieldtype=6)
            if new_rating < old_rating:
                new_rating = int(round((old_rating + new_rating - 0.1) / 2.))
                rr4 = self.UpdateSValueByNID(param_name='field_rating', tnid=nid, ntype=6, new_value=new_rating)
            elif new_rating > old_rating:
                rr4 = self.UpdateSValueByNID(param_name='field_rating', tnid=nid, ntype=6, new_value=new_rating)
            else:
                rr4 = None
            new_last_played = self.ArgumentsArray.get('last_played', 0)
            old_last_played = self.GetFieldByNID(nid=nid, fieldname='field_lastplayed', fieldtype=4)
            if new_last_played > old_last_played:
                rr5 = self.UpdateSValueByNID(param_name='field_lastplayed', tnid=nid, ntype=4, new_value=new_last_played)
            else:
                rr5 = None
            print >> self.stderr_utf, "Update existing track, %s,%s,%s,%s,%s,%s count=%s, rate=%s, rating=%s" % (rr1, rr2, rr3, rr4, rr5, rr6, new_count, new_rate, new_rating)
            return None
        except Exception as e:
            print >> self.stderr_utf, repr(e)
            self.error += repr(e) + '\n'
            self.error_cnt += 1
            return None
    def UpdateExistingPathByNID(self, nid):
        try:
            filesize = self.ArgumentsArray.get('filesize', 0)
            bitrate = self.ArgumentsArray.get('bitrate', 0)
            play_count = self.ArgumentsArray.get('play_count', 0)
            exist = self.ArgumentsArray.get('exist', 0)
            UFID = self.ArgumentsArray.get('UFID', '')          
            old_count = self.GetFieldByNID(nid=nid, fieldname='field_count', fieldtype=4)
            if old_count < play_count:
                rr1 = self.UpdateSValueByNID(param_name='field_count', tnid=nid, ntype=4, new_value=play_count)
                if rr1[0] == 0 and rr1[1] == 0:
                    rr1 = self.AddNodeFieldDataAndRevision(field_type=4, fieldname='field_count', nid=nid, nodetype='filepath', arg_value=play_count)
            else: rr1 = None
                # TODO correct play_count in track
            old_rate = self.GetFieldByNID(nid=nid, fieldname='field_bitrate', fieldtype=4)
            if old_rate != bitrate:
                rr2 = self.UpdateSValueByNID(param_name='field_bitrate', tnid=nid, ntype=4, new_value=bitrate)
            else: rr2 = None
            old_filesize = self.GetFieldByNID(nid=nid, fieldname='field_filesize', fieldtype=4)
            if filesize != old_filesize:
                rr3 = self.UpdateSValueByNID(param_name='field_filesize', tnid=nid, ntype=4, new_value=filesize)
            else: rr3 = None                
            old_exist = self.GetFieldByNID(nid=nid, fieldname='field_exist', fieldtype=4)
            if exist != old_exist:
                rr4 = self.UpdateSValueByNID(param_name='field_exist', tnid=nid, ntype=4, new_value=exist)
            else: rr4 = None
            old_UFID = self.GetFieldByNID(nid=nid, fieldname='field_ufid', fieldtype=1)
            if UFID is None: UFID = ''
            if old_UFID is None: old_UFID = ''
            if UFID.lower() != old_UFID.lower() and UFID != '': # pylint: disable=E1103
                rr5 = self.UpdateSValueByNID(param_name='field_ufid', tnid=nid, ntype=1, new_value=UFID)
            else: rr5 = None  
            self.db_conn.commit()             
            print >> self.stderr_utf, "Update existing filepath, %s,%s,%s,%s,%s count=%s, exist=%s, UFID=%s" % (rr1, rr2, rr3, rr4, rr5, play_count, exist, UFID)
            return None
        except Exception as e:
            print >> self.stderr_utf, repr(e)
            self.error += repr(e) + '\n'
            self.error_cnt += 1
            return None        
    def UpdateSValueByNID(self, param_name, tnid, ntype, new_value):
        try:
            if ntype == 1 or ntype == 2 or ntype == 4: # Text, Number
                sql1 = ('UPDATE field_data_%s SET %s_value=' % (param_name, param_name)) + '%s WHERE entity_type=%s and entity_id=%s and delta=0;'
                sql2 = ('UPDATE field_revision_%s SET %s_value=' % (param_name, param_name)) + '%s WHERE entity_type=%s and entity_id=%s and delta=0;'
            elif ntype == 5: # Node reference
                sql1 = ('UPDATE field_data_%s SET %s_nid=' % (param_name, param_name)) + '%s WHERE entity_type=%s and entity_id=%s and delta=0;'
                sql2 = ('UPDATE field_revision_%s SET %s_nid=' % (param_name, param_name)) + '%s WHERE entity_type=%s and entity_id=%s and delta=0;'
            elif ntype == 6: # rate
                sql1 = ('UPDATE field_data_%s SET %s_rating=' % (param_name, param_name)) + '%s WHERE entity_type=%s and entity_id=%s and delta=0;'
                sql2 = ('UPDATE field_revision_%s SET %s_rating=' % (param_name, param_name)) + '%s WHERE entity_type=%s and entity_id=%s and delta=0;'
            else:
                return -1   
            r1 = self.db_cursor.execute(sql1, (new_value, 'node', tnid))
            r2 = self.db_cursor.execute(sql2, (new_value, 'node', tnid))
            self.db_conn.commit()
            return (r1, r2)
        except Exception as e:
            print >> self.stderr_utf, repr(e)
            self.error += repr(e) + '\n'
            self.error_cnt += 1
            return None  
    def UpdateMVnidByNID(self, param_name, tnid, ntype, new_value):
        try:
            sql = ('SELECT delta,%s_nid as result from field_data_%s ' % (param_name, param_name)) + ' WHERE entity_type=%s and entity_id=%s ORDER BY delta ASC;'
            rn = self.db_cursor.execute(sql, ('node', tnid))
            if rn > 0:
                rr = self.db_cursor.fetchall()
                delta = 0
                for r in rr:
                    delta = r['delta']
                    if r['result'] == new_value: # Уже есть
                        return delta
                # Нет - попали сюда, delta содержит макс существующую
                delta += 1
                rr = self.AddNodeFieldDataAndRevision(field_type=5, fieldname=param_name, nid=tnid, nodetype=ntype, arg_value=new_value, delta=delta)
                self.db_conn.commit()
                return delta
            elif rn == 0:
                rr = self.AddNodeFieldDataAndRevision(field_type=5, fieldname=param_name, nid=tnid, nodetype=ntype, arg_value=new_value, delta='0')
                self.db_conn.commit()                
                return 0
            return -1
        except Exception as e:
            print >> self.stderr_utf, repr(e)
            self.error += repr(e) + '\n'
            self.error_cnt += 1
            return None                       
    def CheckAddNodeType(self, nodetype='', nodefilter='', timestamp=0, nodeschema=0):
        try:
            ft = nodefilter.strip()
            retnode = self.CheckNode(nodetype=nodetype, nodefilter=ft)
            if retnode == 0:
                if nodetype == 'artist':
                    retnode = self.AddNewNode(nodetype=nodetype, title=ft, timestamp=timestamp, nodeschema=1)
                elif nodetype == 'album':
                    retnode = self.AddNewNode(nodetype=nodetype, title=ft, timestamp=timestamp, nodeschema=2)
                elif nodetype == 'genre':
                    retnode = self.AddNewNode(nodetype=nodetype, title=ft, timestamp=timestamp, nodeschema=2)
                elif nodetype == 'filepath':
                    retnode = self.AddNewNode(nodetype=nodetype, title=ft, timestamp=timestamp, nodeschema=3)
                elif nodetype == 'track':
                    retnode = self.AddNewNode(nodetype=nodetype, title=ft, timestamp=timestamp, nodeschema=4)
                else:
                    retnode = self.AddNewNode(nodetype=nodetype, title=ft, timestamp=timestamp, nodeschema=nodeschema)
            if retnode == -1:
                print >> self.stderr_utf, "Error in AddNewNode"
                self.error += "Error in AddNewNode, return -1, Input %s " % repr((nodetype, ft, timestamp, nodeschema))
            else:
                if nodetype == 'track': # существующий трек
                    self.UpdateExistingTrackByNID(retnode)
                elif nodetype == 'filepath': #существующий путь к файлу
                    self.UpdateExistingPathByNID(retnode)
            return retnode
        except Exception as e:
            print >> self.stderr_utf, repr(e)
            self.error += 'Exception in CheckAddNodeType' + repr(e) + '\n'
            self.error_cnt += 1
            return -1
    def AddCurrentParameter(self, name, value):
        try:
            self.ArgumentsArray[name] = value
        except Exception as e:
            print >> self.stderr_utf, repr(e)
            self.error += repr(e) + '\n'
            self.error_cnt += 1
            return -1
    def ClearAllParameters(self):
        self.ArgumentsArray = dict()            
    def AddNewNode(self, nodetype, title, timestamp=0, nodeschema=0):
        try:
            if nodeschema == 0:
                return -1L
            if timestamp == 0:
                self.unixstamp = long(time.time())
            else:
                self.unixstamp = timestamp
            self.error = repr((nodetype, title, timestamp, nodeschema))
            self.db_cursor.execute('START TRANSACTION')
            sql = 'INSERT INTO node (vid, type, language, title, uid, status, created, changed, comment, promote, sticky) VALUES (NULL, %s, %s, %s, %s, %s, %s, %s, %s, %s, %s)'
            if nodeschema == 1 or nodeschema == 2 or nodeschema == 4:
                inp_tuple = (nodetype, 'und', title, self.drupal_uid, '1', str(self.unixstamp), str(self.unixstamp), '2', '1', '0')
            elif nodeschema == 3:
                inp_tuple = (nodetype, 'und', title, self.drupal_uid, '1', str(self.unixstamp), str(self.unixstamp), '2', '0', '0')
            else:
                print >> self.stderr_utf, "Invalid nodeschema"
                self.db_conn.rollback()
                return -1
            ret = self.db_cursor.execute(sql, inp_tuple)
            last_id = self.db_cursor.lastrowid
            sqlr = 'INSERT INTO node_revision (nid, uid, title, log, timestamp, status, comment, promote, sticky) VALUES (%s, %s, %s, %s, %s, %s, %s, %s, %s)'
            if nodeschema == 1 or nodeschema == 2 or nodeschema == 4:
                inp2_tuple = (last_id, self.drupal_uid, title, '', str(self.unixstamp), '1', '2', '1', '0')
            else:
                inp2_tuple = (last_id, self.drupal_uid, title, '', str(self.unixstamp), '1', '2', '0', '0')
            ret2 = self.db_cursor.execute(sqlr, inp2_tuple)
            ret3 = self.db_cursor.execute('UPDATE node SET vid=%s WHERE  nid = %s', (last_id, last_id))
            print >> self.stderr_utf, "Stage 1 [%s]->%s,%s,%s" % (last_id, ret, ret2, ret3)
            # Шаг два
            if nodeschema == 1:
                ret = self.AddNodeFieldDataAndRevision(field_type=2, fieldname='field_description', nid=last_id, nodetype=nodetype, arg_value='<p>' + title + '</p>\n', txt_format='filtered_html')
                ret2 = None
            elif nodeschema == 2:
                ret = self.AddNodeFieldDataAndRevision(field_type=3, fieldname='body', nid=last_id, nodetype=nodetype, arg_value='<h1 class=\"title\">' + title + '</h1>\n', txt_format='filtered_html')
                ret2 = None
            elif nodeschema == 3: # filepath
                ret3 = self.AddNodeFieldDataAndRevision(field_type=1, fieldname='field_uri', nid=last_id, nodetype='filepath', arg_value=self.ArgumentsArray.get('URI', 'Unknown URI - Missing parameter'), txt_format=None)
                ret4 = self.AddNodeFieldDataAndRevision(field_type=4, fieldname='field_filesize', nid=last_id, nodetype='filepath', arg_value=self.ArgumentsArray.get('filesize', '-1'))
                ret5 = self.AddNodeFieldDataAndRevision(field_type=4, fieldname='field_bitrate', nid=last_id, nodetype='filepath', arg_value=self.ArgumentsArray.get('bitrate', '-1'))
                ret6 = self.AddNodeFieldDataAndRevision(field_type=4, fieldname='field_exist', nid=last_id, nodetype='filepath', arg_value=self.ArgumentsArray.get('exist', '0'))
                ret7 = self.AddNodeFieldDataAndRevision(field_type=1, fieldname='field_ufid', nid=last_id, nodetype='filepath', arg_value=self.ArgumentsArray.get('UFID', '00'))
                count = self.ArgumentsArray.get('play_count', -1)
                if count is None or count <= 0:
                    count = '0'
                ret8 = self.AddNodeFieldDataAndRevision(field_type=4, fieldname='field_count', nid=last_id, nodetype='filepath', arg_value=count)
                ret2 = (ret3, ret4, ret5, ret6, ret7, ret8)
            elif nodeschema == 4: 
                year = self.ArgumentsArray.get('year', 1900)
                if year < 1900 or year is None:
                    year = 'NULL'
                else:
                    year = '%s-01-01 00:00:00' % year
                ret3 = self.AddNodeFieldDataAndRevision(field_type=4, fieldname='field_year', nid=last_id, nodetype='track', arg_value=year)
                track_no = self.ArgumentsArray.get('track_number', -1)
                if track_no is None or track_no <= 0:
                    track_no = 'NULL'
                ret4 = self.AddNodeFieldDataAndRevision(field_type=4, fieldname='field_track_no', nid=last_id, nodetype='track', arg_value=track_no)
                disk_no = self.ArgumentsArray.get('disk_number', -1)
                if disk_no is None or disk_no <= 0:
                    disk_no = 'NULL'
                ret5 = self.AddNodeFieldDataAndRevision(field_type=4, fieldname='field_disk_no', nid=last_id, nodetype='track', arg_value=disk_no)
                rate = int(self.ArgumentsArray.get('rate', 0))
                if rate is None or rate <= 0:
                    rate = '0'
                ret6 = self.AddNodeFieldDataAndRevision(field_type=4, fieldname='field_rate', nid=last_id, nodetype='track', arg_value=rate)
                duration = self.ArgumentsArray.get('duration', 0)
                if duration is None or duration <= 0:
                    duration = 'NULL'
                ret7 = self.AddNodeFieldDataAndRevision(field_type=4, fieldname='field_duration', nid=last_id, nodetype='track', arg_value=duration)
                count = self.ArgumentsArray.get('play_count', -1)
                if count is None or count <= 0:
                    count = '0'
                ret8 = self.AddNodeFieldDataAndRevision(field_type=4, fieldname='field_count', nid=last_id, nodetype='track', arg_value=count)
                last_played = self.ArgumentsArray.get('last_played', long(time.time()))
                if last_played is None or last_played <= 0:
                    last_played = long(time.time())
                ret9 = self.AddNodeFieldDataAndRevision(field_type=4, fieldname='field_lastplayed', nid=last_id, nodetype='track', arg_value=last_played)
                ret10 = self.AddNodeFieldDataAndRevision(field_type=5, fieldname='field_artist', nid=last_id, nodetype='track', arg_value=self.ArgumentsArray.get('artist_nid', 'NULL'))
                ret11 = self.AddNodeFieldDataAndRevision(field_type=5, fieldname='field_album', nid=last_id, nodetype='track', arg_value=self.ArgumentsArray.get('album_nid', 'NULL'))
                ret12 = self.AddNodeFieldDataAndRevision(field_type=5, fieldname='field_genre', nid=last_id, nodetype='track', arg_value=self.ArgumentsArray.get('genre_nid', 'NULL'))
                ret13 = self.AddNodeFieldDataAndRevision(field_type=5, fieldname='field_filepath', nid=last_id, nodetype='track', arg_value=self.ArgumentsArray.get('filepath_nid', 'NULL'))
                rating = int(self.ArgumentsArray.get('rating', '0'))
                ret14 = self.AddNodeFieldDataAndRevision(field_type=6, fieldname='field_rating', nid=last_id, nodetype='track', arg_value=rating)
                sqlva1 = 'INSERT INTO votingapi_vote (entity_type, entity_id, value, value_type, tag, uid, timestamp, vote_source) VALUES (%s,%s,%s,%s,%s,%s,%s,%s)'
                va1_tuple = ('node', last_id, rating, 'percent', 'vote', self.drupal_uid, self.unixstamp, '0.0.0.0')
                rv1 = self.db_cursor.execute(sqlva1, va1_tuple)
                sqlva2 = 'INSERT INTO votingapi_cache (entity_type, entity_id, value, value_type, tag, function, timestamp) VALUES (%s,%s,%s,%s,%s,%s,%s)'
                va2_tuple = ('node', last_id, '1', 'percent', 'vote', 'count', self.unixstamp)
                rv2 = self.db_cursor.execute(sqlva2, va2_tuple)
                sqlva3 = 'INSERT INTO votingapi_cache (entity_type, entity_id, value, value_type, tag, function, timestamp) VALUES (%s,%s,%s,%s,%s,%s,%s)'
                va3_tuple = ('node', last_id, rating, 'percent', 'vote', 'average', self.unixstamp)
                rv3 = self.db_cursor.execute(sqlva3, va3_tuple)
                ret2 = (ret3, ret4, ret5, ret6, ret7, ret8, ret9, ret10, ret11, ret12, ret13, ret14, (rv1, rv2, rv3))
            sql3 = 'INSERT INTO node_comment_statistics (nid, cid, last_comment_timestamp, last_comment_name, last_comment_uid, comment_count) VALUES (%s,%s,%s,NULL,%s,%s)'
            last_comm = '0'
            if nodeschema == 1:
                last_comm = last_id
            inp3_tuple = (last_id, last_comm, str(self.unixstamp), self.drupal_uid, '0')
            ret3 = self.db_cursor.execute(sql3, inp3_tuple)
            print >> self.stderr_utf, "Stage 2 Variant=%s [%s]=%s,%s,%s" % (nodeschema, last_id, ret, ret2, ret3)
            # Шаг три
            if nodeschema == 1 or nodeschema == 2 or nodeschema == 4:
                cl_title = title.lower()
            elif nodeschema == 3: # filepath
                cl_title = self.ArgumentsArray.get('title', 'Unknown title')
                cl_title = cl_title.lower()                
                cl_title = cl_title.replace(' ', '_') + '-file'
            else:
                pass
            sql = "SELECT pid FROM url_alias WHERE source <> %s AND alias = %s AND language IN ('und') ORDER BY language DESC, pid DESC LIMIT 0, 1"
            inp_tuple = ('node/%s' % last_id, 'content/%s' % cl_title)
            ret = self.db_cursor.execute(sql, inp_tuple)
            if ret == 0:
                sql3 = 'INSERT INTO url_alias (source, alias, language) VALUES (%s,%s,%s)'
                inp2_tuple = ('node/%s' % last_id, 'content/%s' % cl_title, 'und')
                ret2 = self.db_cursor.execute(sql3, inp2_tuple)
                print >> self.stderr_utf, "Stage 3 [%s]=,%s,%s" % (cl_title, ret, ret2)
            else:
                # Если такие есть, нужно добавить некоторое число в конце
                nn = 0
                sql3 = 'INSERT INTO url_alias (source, alias, language) VALUES (%s,%s,%s)'
                while ret != 0:
                    inp_tuple = ('node/%s' % (last_id,), 'content/%s-%s' % (cl_title, nn))
                    ret = self.db_cursor.execute(sql, inp_tuple)
                    if ret == 0:
                        inp2_tuple = ('node/%s' % last_id, 'content/%s-%s' % (cl_title, nn), 'und')
                        ret2 = self.db_cursor.execute(sql3, inp2_tuple)
                        print >> self.stderr_utf, "Stage 3 (repeat) [%s]=%s,%s,%s" % (cl_title, nn, ret, ret2)
                    nn += 1
            self.db_conn.commit()
            return last_id
        except Exception as e:
            try:
                self.db_conn.rollback()
            except Exception as ee:
                print >> self.stderr_utf, repr(ee)
            print >> self.stderr_utf, repr(e)
            self.error += repr(e) + '\n'
            self.error_cnt += 1
            return -1   
    def AddNodeField(self, field_type=0, fieldname='#ERROR#', nid= -1L, nodetype='#ERROR#', arg_value='#ERROR#', txt_format='#ERROR#', delta=0):
        try:
            if field_type == 1: # Text field with FORMAT==NULL
                sql = ('INSERT INTO field_data_%s (entity_type, entity_id, revision_id, bundle, delta, language, %s_value, %s_format)' % (fieldname, fieldname, fieldname)) + ' VALUES (%s,%s,%s,%s,%s,%s,%s, NULL);'
                inp_tuple = ('node', nid, nid, nodetype, delta, 'und', arg_value)
            elif field_type == 2: # Text field with 'filtered_html'
                sql = ('INSERT INTO field_data_%s (entity_type, entity_id, revision_id, bundle, delta, language, %s_value, %s_format)' % (fieldname, fieldname, fieldname)) + ' VALUES (%s,%s,%s,%s,%s,%s,%s,%s);'
                inp_tuple = ('node', nid, nid, nodetype, delta, 'und', arg_value, txt_format)
            elif field_type == 3: # Body
                sql = 'INSERT INTO field_data_body (entity_type, entity_id, revision_id, bundle, delta, language, body_value, body_summary, body_format) VALUES (%s,%s,%s,%s,%s,%s,%s,%s,%s)'
                inp_tuple = ('node', nid, nid, nodetype, delta, 'und', arg_value, '', txt_format)
            elif field_type == 4: # Numeric type
                if arg_value == 'NULL':
                    fd_val = 'NULL'
                    inp_tuple = ('node', nid, nid, nodetype, delta, 'und')
                else:
                    fd_val = '%s'
                    inp_tuple = ('node', nid, nid, nodetype, delta, 'und', arg_value)
                sql = ('INSERT INTO field_data_%s (entity_type, entity_id, revision_id, bundle, delta, language, %s_value)' % (fieldname, fieldname)) + ' VALUES (%s,%s,%s,%s,%s,%s,' + fd_val + ');'
            elif field_type == 5: # Node link type
                sql = ('INSERT INTO field_data_%s (entity_type, entity_id, revision_id, bundle, delta, language, %s_nid)' % (fieldname, fieldname)) + ' VALUES (%s,%s,%s,%s,%s,%s,%s);'
                inp_tuple = ('node', nid, nid, nodetype, delta, 'und', arg_value)
            elif field_type == 6: # Rating type
                sql = ('INSERT INTO field_data_%s (entity_type, entity_id, revision_id, bundle, delta, language, %s_rating, %s_target)' % (fieldname, fieldname, fieldname)) + ' VALUES (%s,%s,%s,%s,%s,%s,%s,NULL);'
                inp_tuple = ('node', nid, nid, nodetype, delta, 'und', arg_value)                
            else:
                print >> self.stderr_utf, "Invalid type in AddNodeField"
            return self.db_cursor.execute(sql, inp_tuple)
        except Exception as e:
            print >> self.stderr_utf, repr(e)
            self.error += repr(e) + '\n'
            self.error_cnt += 1
            return -1
    def AddNodeFieldRevision(self, field_type=0, fieldname='#ERROR#', nid= -1L, nodetype='#ERROR#', arg_value='#ERROR#', txt_format='#ERROR', delta=0):
        try:
            if field_type == 1: # Text field with FORMAT==NULL
                sql = ('INSERT INTO field_revision_%s (entity_type, entity_id, revision_id, bundle, delta, language, %s_value, %s_format)' % (fieldname, fieldname, fieldname)) + ' VALUES (%s,%s,%s,%s,%s,%s,%s, NULL)'
                inp_tuple = ('node', nid, nid, nodetype, delta, 'und', arg_value)
            elif field_type == 2: # Text field with 'filtered_html'
                sql = ('INSERT INTO field_revision_%s (entity_type, entity_id, revision_id, bundle, delta, language, %s_value, %s_format)' % (fieldname, fieldname, fieldname)) + ' VALUES (%s,%s,%s,%s,%s,%s,%s,%s)'
                inp_tuple = ('node', nid, nid, nodetype, delta, 'und', arg_value, txt_format)
            elif field_type == 3:
                sql = 'INSERT INTO field_revision_body (entity_type, entity_id, revision_id, bundle, delta, language, body_value, body_summary, body_format) VALUES (%s,%s,%s,%s,%s,%s,%s,%s,%s)'
                inp_tuple = ('node', nid, nid, nodetype, delta, 'und', arg_value, '', 'filtered_html')
            elif field_type == 4: # Numeric type
                if arg_value == 'NULL':
                    fd_val = 'NULL'
                    inp_tuple = ('node', nid, nid, nodetype, delta, 'und')
                else:                    
                    inp_tuple = ('node', nid, nid, nodetype, delta, 'und', arg_value)
                    fd_val = '%s'
                sql = ('INSERT INTO field_revision_%s (entity_type, entity_id, revision_id, bundle, delta, language, %s_value)' % (fieldname, fieldname)) + '  VALUES (%s,%s,%s,%s,%s,%s,' + fd_val + ');'
            elif field_type == 5: # Node link type
                inp_tuple = ('node', nid, nid, nodetype, delta, 'und', arg_value)
                sql = ('INSERT INTO field_revision_%s (entity_type, entity_id, revision_id, bundle, delta, language, %s_nid)' % (fieldname, fieldname)) + '  VALUES (%s,%s,%s,%s,%s,%s,%s);'
            elif field_type == 6: # Rating type
                inp_tuple = ('node', nid, nid, nodetype, delta, 'und', arg_value)
                sql = ('INSERT INTO field_revision_%s (entity_type, entity_id, revision_id, bundle, delta, language, %s_rating, %s_target)' % (fieldname, fieldname, fieldname)) + '  VALUES (%s,%s,%s,%s,%s,%s,%s,NULL);'
            else:
                print >> self.stderr_utf, "Invalid type in AddNodeField"    
            return self.db_cursor.execute(sql, inp_tuple)
        except Exception as e:
            print >> self.stderr_utf, repr(e)
            self.error += repr(e) + '\n'
            self.error_cnt += 1
            return -1
    def AddNodeFieldDataAndRevision(self, field_type=0, fieldname='#ERROR#', nid= -1L, nodetype='#ERROR#', arg_value='#ERROR#', txt_format='#ERROR', delta=0):
        r1 = self.AddNodeField(field_type=field_type, fieldname=fieldname, nid=nid, nodetype=nodetype, arg_value=arg_value, txt_format=txt_format, delta=delta)
        r2 = self.AddNodeFieldRevision(field_type=field_type, fieldname=fieldname, nid=nid, nodetype=nodetype, arg_value=arg_value, txt_format=txt_format, delta=delta)            
        return (r1, r2)
    def SetArguments(self, nodeArguments=None):
        try:
            self.ArgumentsArray = nodeArguments
            return 0
        except Exception as e:
            print >> self.stderr_utf, repr(e)
            self.error += repr(e) + '\n'
            self.error_cnt += 1
            return -1                                 
    def __init__(self, ConfigFileName=u'~/.local/musstatstore.conf'):
        '''
        Constructor
        '''
        self.stdout_utf = codecs.getwriter('utf8')(sys.stdout)
        self.stderr_utf = codecs.getwriter('utf8')(sys.stderr)
        self.ReadConfigFile(FileName=ConfigFileName)
        self.OpenDBConnection()
        self.unixstamp = long(time.time())
