#! /usr/bin/python
# -*- coding: utf-8 -*-
'''
Created on 12.09.2012

@author: tolmi
'''
import ConfigParser, MySQLdb, sys, os, codecs, base64, time

class StoreDrupal6DB(object):
    '''
    classdocs
        Пока ничего не придумал. А в связи с глобальной ленью скорее всего никогда и не напишу.
    '''    
    error = ''
    error_cnt = 0
    error_cnt_imm = 0
    db_host = ''
    db_base = ''
    db_user = ''
    db_passwd = ''
    db_conn = None
    db_cursor = None
    drupal_uid = 1
    sConfigFileName = u''
    unixstamp = 0L
    last_query_rows = 0L
    def Err_Handling(self, e=None):
        print >> sys.stderr, repr(e)
        self.error += repr(e) + '\n'
        self.error_cnt += 1
    def UpdateCountField(self, t_nid, new_value):
        try:
            sql = 'UPDATE content_type_track SET field_count_value=%s WHERE nid=%s;'
            r1 = self.db_cursor.execute(sql, (new_value,t_nid))
            return r1
        except Exception as e: 
            self.Err_Handling(e)
            return None                     
    def DeleteHistoryRecord(self, th_vid):
        try:
            sql = 'DELETE FROM content_type_track_history WHERE vid=%s;'
            r1 = self.db_cursor.execute(sql, (th_vid,))
            return r1
        except Exception as e: 
            self.Err_Handling(e)
            return None             
    def insertNewHistoryRecord(self, th_nid, th_time=int(time.time())):
        try:
            r1 = self.db_cursor.execute('SELECT MAX(nid) as result from content_type_track_history;')
            r2 = self.db_cursor.fetchone()
            next_nid = r2['result'] + 1
            sql = 'INSERT INTO content_type_track_history (nid,vid,field_track_nid,field_date_001_value) VALUES (%s,%s,%s,%s)'
            inptup = (next_nid, next_nid, th_nid, th_time)
            r3 = self.db_cursor.execute(sql, inptup)
            return (r1, r2, r3)
        except Exception as e: 
            self.Err_Handling(e)
            return None     
    def insertNewPlayHistoryRecord(self, th_nid, th_time=int(time.time()), r_filter=''):
        try:
            sql = 'INSERT INTO playhistory (ptime,nid,type) VALUES (%s,%s,%s)'
            inptup = (th_time, th_nid, r_filter)
            r1 = self.db_cursor.execute(sql, inptup)
            return r1
        except Exception as e: 
            self.Err_Handling(e)
            return None                                      
    def GetMaxTimeFromPlayHistory(self):
        try:
            rr = self.db_cursor.execute('SELECT MAX(ptime) as result from playhistory;')
            if rr < 1:
                return None
            else:
                rr = self.db_cursor.fetchone()
                return rr.get('result')
        except Exception as e: 
            self.Err_Handling(e)
            return None
    def GetAllTrackHistory(self, t_nid):
        try:
            rr = self.db_cursor.execute('SELECT * from content_type_track_history WHERE field_track_nid=%s ORDER BY field_date_001_value ASC', (t_nid,))
            if rr < 1:
                return None
            else:
                return self.db_cursor.fetchall()
        except Exception as e: 
            self.Err_Handling(e)
    def GetTrackDetailInformation(self, tnid):
        try:
            sql = 'SELECT node.title,node.created,node_revisions.body,node_revisions.teaser,content_type_track.* from node,node_revisions,content_type_track where node.nid=node_revisions.nid and content_type_track.nid=node.nid and node.nid=%s;'
            inp_tuple = (tnid,)
            rr = self.db_cursor.execute(sql, inp_tuple)
            if rr != 1:
                return None
            else:
                return self.db_cursor.fetchone()
        except Exception as e: 
            self.Err_Handling(e)
    def GetAllNodeByType(self, ftype):
        try:
            sql = 'SELECT nid,title,created from node where type=%s order by nid ASC;'
            inp_tuple = (ftype,)
            self.last_query_rows = self.db_cursor.execute(sql, inp_tuple)
            return self.db_cursor.fetchall()
        except Exception as e:
            print >> sys.stderr, repr(e)
            self.error += repr(e) + '\n'
            self.error_cnt += 1
    def GetTitleByNID(self, nid):
        try:
            sql = 'SELECT nid,title from node where nid=%s order by nid ASC;'
            self.last_query_rows = self.db_cursor.execute(sql, (nid,))
            rr = self.db_cursor.fetchall()
            if self.last_query_rows > 1:
                rra = []
                for r in rr:
                    rra.append(r['title'])
                return rra
            elif self.last_query_rows == 1:
                return rr[0].get('title')
            else:
                return None
        except Exception as e:
            print >> sys.stderr, repr(e)
            self.error += repr(e) + '\n'
            self.error_cnt += 1
            return None                              
    def StorePairNids(self, snid, dnid, ntype):
        try:
            sql = 'INSERT INTO migration (snid,dnid,type) VALUES (%s,%s,%s);'
            inp_tuple = (snid, dnid, ntype)
            ret = self.db_cursor.execute(sql, inp_tuple)
            return ret
        except MySQLdb.Error, e:
            print >> sys.stderr, repr(e)
        except Exception as e:
            print >> sys.stderr, repr(e)
            self.error += repr(e) + '\n'
            self.error_cnt += 1
    def GetDestNidBySrc_fromMigration(self, snid):
        try:
            sql = 'SELECT * FROM migration WHERE snid=%s;'
            inp_tuple = (snid,)
            ret = self.db_cursor.execute(sql, inp_tuple)
            if ret != 1:
                return -1L
            row = self.db_cursor.fetchone()
            return row['dnid']
        except Exception as e:
            print >> sys.stderr, repr(e)
            self.error += repr(e) + '\n'
            self.error_cnt += 1            
    def ReadConfigFile(self, FileName):
        try:
            self.sConfigFileName = os.path.expanduser(FileName)
            cfp = ConfigParser.ConfigParser()
            conf_fp = codecs.open(self.sConfigFileName, "r+t", 'utf8')
            cfp.readfp(conf_fp)
            self.db_host = cfp.get(section='source-database', option='hostname')    
            self.db_base = cfp.get(section='source-database', option='dbname')
            self.db_user = cfp.get(section='source-database', option='dbuser')
            self.db_passwd = base64.b64decode(cfp.get(section='source-database', option='dbpassword'))
            self.drupal_uid = cfp.getint(section='source-drupal', option='uid')
            conf_fp.close()
        except Exception as e:
            print >> sys.stderr, repr(e)
            self.error += repr(e) + '\n'
            self.error_cnt += 1
    def OpenDBConnection(self):
        try:
            if self.db_conn != None:
                try:
                    self.db_conn.close()
                except:
                    pass
            self.db_conn = MySQLdb.connect(host=self.db_host, user=self.db_user, passwd=self.db_passwd, db=self.db_base, use_unicode=1, charset='utf8')
            self.db_conn.set_character_set('utf8')
            self.db_cursor = self.db_conn.cursor(MySQLdb.cursors.DictCursor)
            self.db_cursor.execute('SET NAMES utf8')
            self.db_cursor.execute('SET CHARACTER SET utf8')
            self.db_cursor.execute('SET character_set_connection=utf8')
            self.db_cursor.execute("SET sql_mode = 'ANSI,STRICT_TRANS_TABLES,STRICT_ALL_TABLES,NO_ZERO_IN_DATE,NO_ZERO_DATE,ERROR_FOR_DIVISION_BY_ZERO,NO_AUTO_CREATE_USER'")
        except Exception as e:
            print >> sys.stderr, repr(e)
            self.error += repr(e) + '\n'
            self.error_cnt += 1
    def CheckNode(self, nodetype='', nodefilter=''):
        try:
            sql = "SELECT nid FROM node WHERE type=%s AND title = %s ;"
            numrows = self.db_cursor.execute(sql, (nodetype, nodefilter))
            if numrows < 1 :
                return 0
            r = self.db_cursor.fetchone()
            return r['nid']
        except Exception as e:
            print >> sys.stderr, repr(e)
            self.error += repr(e) + '\n'
            self.error_cnt += 1
    def CheckAddNodeType1(self, nodetype='', nodefilter=''):
        try:
            ft = nodefilter.strip()
            retnode = self.CheckNode(nodetype=nodetype, nodefilter=ft)
            if retnode == 0:
                retnode = self.AddNewNode(nodetype=nodetype, title=ft)
            else:
                return retnode
        except Exception as e:
            print >> sys.stderr, repr(e)
            self.error += repr(e) + '\n'
            self.error_cnt += 1
            return -1
    def CheckNodeInMigration(self, nid=1, nodefilter=''):
        try:
            sql = 'SELECT * FROM migration WHERE snid=%s and type=%s'
            inp_tuple = (nid, nodefilter)
            ret = self.db_cursor.execute(sql, inp_tuple)
            if ret != 0:
                rr = self.db_cursor.fetchone()
                return rr['dnid']
            else:
                return 0
        except Exception as e:
            print >> sys.stderr, repr(e)
            self.error += repr(e) + '\n'
            self.error_cnt += 1
            return -1        
    def AddNewNode(self, nodetype, title):
        try:
            self.unixstamp = long(time.time())
            self.db_cursor.execute('START TRANSACTION')
            sql = 'INSERT INTO node (vid, type, language, title, uid, status, created, changed, comment, promote, sticky) VALUES (NULL, %s, %s, %s, %s, %s, %s, %s, %s, %s, %s)'
            inp_tuple = (nodetype, 'und', title, self.drupal_uid, '1', str(self.unixstamp), str(self.unixstamp), '2', '0', '0')
            ret = self.db_cursor.execute(sql, inp_tuple)
            last_id = self.db_cursor.lastrowid
            sqlr = 'INSERT INTO node_revision (nid, uid, title, log, timestamp, status, comment, promote, sticky) VALUES (%s, %s, %s, %s, %s, %s, %s, %s, %s)'
            inp2_tuple = (last_id, self.drupal_uid, title, '', str(self.unixstamp), '1', '2', '0', '0')
            ret2 = self.db_cursor.execute(sqlr, inp2_tuple)
            ret3 = self.db_cursor.execute('UPDATE node SET vid=%s WHERE  nid = %s', (last_id, last_id))
            print >> sys.stderr, "Stage 1 %s,%s,%s,%s\n" % (ret, last_id, ret2, ret3)
            # Шаг два
            self.db_conn.commit()
            return last_id
        except Exception as e:
            try:
                self.db_conn.rollback()
            except Exception as ee:
                print >> sys.stderr, repr(ee)
            print >> sys.stderr, repr(e)
            self.error += repr(e) + '\n'
            self.error_cnt += 1
            return -1
    def Commit(self):
        try:
            self.db_conn.commit()
        except Exception as e:
            print >> sys.stderr, repr(e)
            self.error += repr(e) + '\n'
            self.error_cnt += 1
    def __init__(self, ConfigFileName=u'~/.local/musstatcopy.conf'):
        '''
        Constructor
        '''
        self.ReadConfigFile(FileName=ConfigFileName)
        self.OpenDBConnection()
        self.unixstamp = long(time.time())
